import MuseScore 3.0
import QtQuick 2.9
import QtQuick.Controls 2.2
import QtQuick.Layouts 1.2
import QtQuick.Dialogs 1.2
import QtQuick.Window 2.2
MuseScore {
  menuPath: "Plugins.spinbox"
  id: pluginscope
  property real wrapperwidth: 0
  property bool fixsize:false
  property int  pagemargintb:10; property int pagemarginlr:20
  property real customwidth: Screen.desktopAvailableWidth*.5
  property real customheight: Screen.desktopAvailableHeight*.5
  property var pk
  function handlearrow(event){
    console.log("event.key: "+event.key)  //https://doc.qt.io/qt-5/qt.html#Key-enum
    pk=event.key
    if (event.key == Qt.Key_Up) console.log("Up") 
    if (event.key == Qt.Key_Down) console.log("Down") 
    if (event.key == Qt.Key_Left) console.log("Left") 
    if (event.key == Qt.Key_Right) console.log("Right")
  }
  onRun:{
    if(fixsize){
      plugindialog.width =Math.min(customwidth  ,Screen.desktopAvailableWidth)
      plugindialog.height=Math.min(customheight ,Screen.desktopAvailableWidth)
    }else{
      // plugindialog doesn't auto expand by contentItem : qml bug ?
      plugindialog.width =Math.min( Math.max(wrapperwidth, plugincontent.width) ,Screen.desktopAvailableWidth)
      // height is tricky
      setTimeout.createObject(pluginscope,{ interval:1 ,running:true  }).triggered.connect(function(){ 
        plugindialog.height=Math.min(  grid.height+plugincontent.footer.height ,Screen.desktopAvailableHeight)
      })
    }
  }
  Component { id: setTimeout ; Timer {  } }
  Dialog { id:plugindialog
    title: "Spinbox"
    visible:true
    contentItem:Page{ id:plugincontent
      contentItem:Rectangle{ id:pagecontent
        color: "beige" 
        Flickable{ 
          anchors.fill:parent;
          contentWidth: allcontent.width; contentHeight: allcontent.height
          GridLayout{ id:grid
            columns: 1
            Column{ id:allcontent
              Layout.preferredWidth: pagecontent.width-Layout.leftMargin-Layout.rightMargin 
              Layout.leftMargin : pagemarginlr; Layout.rightMargin  :pagemarginlr
              Layout.topMargin  : pagemargintb; Layout.bottomMargin :pagemargintb
              Column{ id:innercontent
                width: parent.width
                //
                // Contents here
                  SpinBox { id:spinbox
                    value:0
                  }
                  Button{ 
                    text:"keylog: "+pk 
                    onClicked:console.log("logger")
                    Keys.onPressed: handlearrow(event)
                  }
                  Item { focus:true  ; Keys.onPressed: handlearrow(event)  }
              }
            }
          }
        }
      }
      footer: DialogButtonBox { //  ToolBar, TabBar, or DialogButtonBox  // ms3 Page footer is not bugged
        background: Rectangle { color: "darkgrey"}
        Button {
          text: 'OK'
          DialogButtonBox.buttonRole: DialogButtonBox.AcceptRole
          Keys.onPressed: handlearrow(event) 
        }
        Button {
          text: 'Cancel'
          DialogButtonBox.buttonRole: DialogButtonBox.RejectRole
          Keys.onPressed: handlearrow(event) 
        }
        onAccepted: console.log("ok")
        onRejected: { console.log("cancel"); plugindialog.visible=false }
      }
    }
    // footer: Item{} // ms3 Dialog bug : Cannot assign to non-existent property "footer"
  }
}